diff --git a/pki/base/silent/src/com/netscape/pkisilent/ConfigureOCSP.java b/pki/base/silent/src/com/netscape/pkisilent/ConfigureOCSP.java
index 7e481c79159eacb78212c04e1ba579181937fa01..bf599ed4c0a8446d4ccd4125ed11368eba79071a 100644
--- a/pki/base/silent/src/com/netscape/pkisilent/ConfigureOCSP.java
+++ b/pki/base/silent/src/com/netscape/pkisilent/ConfigureOCSP.java
@@ -207,7 +207,6 @@ public class ConfigureOCSP {
     }
 
     public boolean TokenChoicePanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -257,7 +256,6 @@ public class ConfigureOCSP {
     }
 
     public boolean DomainPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -283,14 +281,10 @@ public class ConfigureOCSP {
     }
 
     public boolean DisplayChainPanel() {
-        boolean st = false;
-        HTTPResponse hr = null;
-        ByteArrayInputStream bais = null;
-        ParseXML px = new ParseXML();
         String query_string = null;
 
         query_string = "p=4" + "&op=next" + "&xml=true";
-        hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
+        hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
         // parse xml
         // bais = new ByteArrayInputStream(hr.getHTML().getBytes());
         // px.parse(bais);
@@ -301,10 +295,7 @@ public class ConfigureOCSP {
     }
 
     public boolean SecurityDomainLoginPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
-        ByteArrayInputStream bais = null;
-        ParseXML px = new ParseXML();
 
         String ocsp_url = "https://" + cs_hostname + ":" + cs_port +
                             "/ocsp/admin/console/config/wizard" +
@@ -349,7 +340,6 @@ public class ConfigureOCSP {
     }
 
     public boolean SubsystemPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -369,7 +359,6 @@ public class ConfigureOCSP {
     }
 
     public boolean LdapConnectionPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -397,7 +386,6 @@ public class ConfigureOCSP {
     }
 
     public boolean KeyPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -460,7 +448,6 @@ public class ConfigureOCSP {
     }
 
     public boolean CertSubjectPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -518,14 +505,9 @@ public class ConfigureOCSP {
     }
 
     public boolean CertificatePanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
-        ArrayList<String> req_list = null;
-        ArrayList<String> cert_list = null;
-        ArrayList<String> dn_list = null;
-        ArrayList<String> pp_list = null;
 
         String query_string = "p=10" + "&op=next" + "&xml=true" +
                             "&subsystem=" +
@@ -556,7 +538,6 @@ public class ConfigureOCSP {
     }
 
     public boolean BackupPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -577,10 +558,7 @@ public class ConfigureOCSP {
     }
 
     public boolean SavePKCS12Panel() {
-        boolean st = false;
         HTTPResponse hr = null;
-        ByteArrayInputStream bais = null;
-        ParseXML px = new ParseXML();
 
         String query_string = "";
 
@@ -601,7 +579,7 @@ public class ConfigureOCSP {
             String line = null;
             while ((line = br.readLine()) != null)
                 System.out.println("Error: " + line);
-            int exitVal = proc.waitFor();
+            proc.waitFor();
 
             // verify p12 file
 
@@ -628,7 +606,6 @@ public class ConfigureOCSP {
     }
 
     public boolean AdminCertReqPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -690,8 +667,6 @@ public class ConfigureOCSP {
     public boolean AdminCertImportPanel() {
         boolean st = false;
         HTTPResponse hr = null;
-        ByteArrayInputStream bais = null;
-        ParseXML px = new ParseXML();
 
         String query_string = "serialNumber=" + admin_serial_number +
                             "&importCert=" + "true" +
@@ -729,7 +704,6 @@ public class ConfigureOCSP {
     }
 
     public boolean UpdateDomainPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
diff --git a/pki/base/silent/src/com/netscape/pkisilent/ConfigureRA.java b/pki/base/silent/src/com/netscape/pkisilent/ConfigureRA.java
index a9345cc5f01c51ba81abb10c6dba84a5b32bf739..d8a6c7feb9226f86409527e26c9923e7ce41b7bd 100644
--- a/pki/base/silent/src/com/netscape/pkisilent/ConfigureRA.java
+++ b/pki/base/silent/src/com/netscape/pkisilent/ConfigureRA.java
@@ -20,7 +20,6 @@ package com.netscape.pkisilent;
 
 import java.io.ByteArrayInputStream;
 import java.net.URLEncoder;
-import java.util.ArrayList;
 
 import com.netscape.osutil.OSUtil;
 import com.netscape.pkisilent.argparser.ArgParser;
@@ -160,7 +159,6 @@ public class ConfigureRA {
     }
 
     public boolean DomainPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -186,24 +184,15 @@ public class ConfigureRA {
     }
 
     public boolean DisplayChainPanel() {
-        boolean st = false;
-        HTTPResponse hr = null;
-        ByteArrayInputStream bais = null;
-        ParseXML px = new ParseXML();
-        String query_string = null;
-
-        query_string = "p=2" + "&op=next" + "&xml=true";
-        hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
+        String query_string = "p=2" + "&op=next" + "&xml=true";
+        hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
         return true;
 
     }
 
     public boolean SecurityDomainLoginPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
-        ByteArrayInputStream bais = null;
-        ParseXML px = new ParseXML();
 
         String ra_url = "https://" + cs_hostname + ":" + cs_port +
                             "/ra/admin/console/config/wizard" +
@@ -247,7 +236,6 @@ public class ConfigureRA {
     }
 
     public boolean SubsystemPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -285,7 +273,6 @@ public class ConfigureRA {
     }
 
     public boolean DBPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -305,7 +292,6 @@ public class ConfigureRA {
     }
 
     public boolean TokenChoicePanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -363,7 +349,6 @@ public class ConfigureRA {
     }
 
     public boolean KeyPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -392,13 +377,9 @@ public class ConfigureRA {
     }
 
     public boolean CertSubjectPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
-        ArrayList<String> req_list = null;
-        ArrayList<String> cert_list = null;
-        ArrayList<String> dn_list = null;
 
         String ca_url = "https://" + ca_hostname + ":" + ca_ssl_port;
 
@@ -426,7 +407,6 @@ public class ConfigureRA {
     }
 
     public boolean CertificatePanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -450,7 +430,6 @@ public class ConfigureRA {
     }
 
     public boolean AdminCertReqPanel() {
-        boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
diff --git a/pki/base/silent/src/com/netscape/pkisilent/common/ComCrypto.java b/pki/base/silent/src/com/netscape/pkisilent/common/ComCrypto.java
index 1c308e2c25d41abca4ffe950746618340ca1c776..d619afcc26075f9f692509a1bc4afc61de6063c1 100644
--- a/pki/base/silent/src/com/netscape/pkisilent/common/ComCrypto.java
+++ b/pki/base/silent/src/com/netscape/pkisilent/common/ComCrypto.java
@@ -248,7 +248,7 @@ public class ComCrypto {
                 System.out.println("Manager object is null");
             }
 
-            X509Certificate cert = manager.importCertPackage(tmp.getBytes(), cn);
+            manager.importCertPackage(tmp.getBytes(), cn);
 
             return true;
 
@@ -277,7 +277,7 @@ public class ComCrypto {
                 System.out.println("Manager object is null");
             }
 
-            X509Certificate cert = manager.importCACertPackage(tmp.getBytes());
+            manager.importCACertPackage(tmp.getBytes());
 
             return true;
 
diff --git a/pki/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java b/pki/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
index cad7d0ae3452617dea6ce7b84c62d838e5154a01..0a10f9ccb6af8bb1d3313467b97247a621457789 100644
--- a/pki/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
+++ b/pki/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
@@ -1016,7 +1016,6 @@ public class CryptoUtil {
      */
     public static void deletePrivateKey(PrivateKey prikey)
             throws CryptoManager.NotInitializedException, TokenException {
-        CryptoManager cm = CryptoManager.getInstance();
 
         try {
             CryptoToken token = prikey.getOwningToken();
diff --git a/pki/base/util/src/com/netscape/cmsutil/http/JssSSLSocketFactory.java b/pki/base/util/src/com/netscape/cmsutil/http/JssSSLSocketFactory.java
index 791549812d90dc9e3150027b53863ef15850c443..d0bef4b2a2b7371824d03d4e748bf40f4f62df71 100644
--- a/pki/base/util/src/com/netscape/cmsutil/http/JssSSLSocketFactory.java
+++ b/pki/base/util/src/com/netscape/cmsutil/http/JssSSLSocketFactory.java
@@ -132,7 +132,7 @@ public class JssSSLSocketFactory implements ISocketFactory {
                 // report error if the nickName is invalid.
                 // So we check this ourself using
                 // findCertByNickname
-                X509Certificate cert = CryptoManager.getInstance().findCertByNickname(mClientAuthCertNickname);
+                CryptoManager.getInstance().findCertByNickname(mClientAuthCertNickname);
 
                 s.setClientCertNickname(mClientAuthCertNickname);
             }
diff --git a/pki/base/util/src/com/netscape/cmsutil/password/IPasswordReader.java b/pki/base/util/src/com/netscape/cmsutil/password/IPasswordReader.java
index 357ae0a6cc50c9ed7682c2344a0729c1466562fd..759e9e7777e0856a9a4057d5c562e9ab367c2f8d 100644
--- a/pki/base/util/src/com/netscape/cmsutil/password/IPasswordReader.java
+++ b/pki/base/util/src/com/netscape/cmsutil/password/IPasswordReader.java
@@ -25,5 +25,5 @@ public interface IPasswordReader {
 
     public String getPassword(String tag);
 
-    public Enumeration getTags();
+    public Enumeration<String> getTags();
 }
diff --git a/pki/base/util/src/com/netscape/cmsutil/password/IPasswordStore.java b/pki/base/util/src/com/netscape/cmsutil/password/IPasswordStore.java
index f2e9293d33004c2fa6893382a460bcb9f8ced57c..49b2610fa8a47cb6e9b712a05d887d22cb491c29 100644
--- a/pki/base/util/src/com/netscape/cmsutil/password/IPasswordStore.java
+++ b/pki/base/util/src/com/netscape/cmsutil/password/IPasswordStore.java
@@ -25,7 +25,7 @@ public interface IPasswordStore {
 
     public String getPassword(String tag);
 
-    public Enumeration getTags();
+    public Enumeration<String> getTags();
 
     public Object putPassword(String tag, String password);
 
diff --git a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java
index 91a45ca3bce9fdedd62c803287a5bf5cd5c70b58..eb43607f0fdbe1d7017886f742b5a29d64bdb587 100644
--- a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java
+++ b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java
@@ -22,6 +22,7 @@ import java.io.FileOutputStream;
 import java.io.IOException;
 import java.util.Enumeration;
 import java.util.Properties;
+import java.util.Vector;
 
 public class PlainPasswordFile implements IPasswordStore {
     private String mPwdPath = "";
@@ -47,8 +48,13 @@ public class PlainPasswordFile implements IPasswordStore {
     }
 
     // return an array of String-based tag
-    public Enumeration<?> getTags() {
-        return mPwdStore.propertyNames();
+    public Enumeration<String> getTags() {
+        Enumeration<?> e = mPwdStore.propertyNames();
+        Vector<String> v = new Vector<String>();
+        while (e.hasMoreElements()) {
+            v.add((String) e.nextElement());
+        }
+        return v.elements();
     }
 
     public Object putPassword(String tag, String password) {
diff --git a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java
index 10f33350c615feda77520337fa51e19866c5075b..68724a9f661a1c031edbae4a060052005fb56b90 100644
--- a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java
+++ b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java
@@ -21,6 +21,7 @@ import java.io.FileInputStream;
 import java.io.IOException;
 import java.util.Enumeration;
 import java.util.Properties;
+import java.util.Vector;
 
 public class PlainPasswordReader implements IPasswordReader {
     private String mPwdPath = "";
@@ -46,7 +47,12 @@ public class PlainPasswordReader implements IPasswordReader {
     }
 
     // return an array of String-based tag
-    public Enumeration<?> getTags() {
-        return mPwdStore.propertyNames();
+    public Enumeration<String> getTags() {
+        Enumeration<?> e = mPwdStore.propertyNames();
+        Vector<String> v = new Vector<String>();
+        while (e.hasMoreElements()) {
+            v.add((String) e.nextElement());
+        }
+        return v.elements();
     }
 }
diff --git a/pki/base/util/src/com/netscape/cmsutil/util/Utils.java b/pki/base/util/src/com/netscape/cmsutil/util/Utils.java
index 6f4ba4976593b17d439beca8eac02b9a38bf3816..07916fb6af0ce0ce17ba4523b834bd571b3c8edc 100644
--- a/pki/base/util/src/com/netscape/cmsutil/util/Utils.java
+++ b/pki/base/util/src/com/netscape/cmsutil/util/Utils.java
@@ -145,7 +145,7 @@ public class Utils {
     }
 
     public static void checkHost(String hostname) throws UnknownHostException {
-        InetAddress addr = InetAddress.getByName(hostname);
+        InetAddress.getByName(hostname);
     }
 
     public static void copy(String orig, String dest) {
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS7.java b/pki/base/util/src/netscape/security/pkcs/PKCS7.java
index b28c570c3f4307174ad677f76284e344dd843b9b..4de75a4e1a812eee6650257523f1d91ccc785f55 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS7.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS7.java
@@ -272,9 +272,6 @@ public class PKCS7 {
         // contentInfo
         contentInfo.encode(signedData);
 
-        // certificates
-        DerOutputStream certs = new DerOutputStream();
-
         // cast to X509CertImpl[] since X509CertImpl implements DerEncoder
         X509CertImpl implCerts[] = new X509CertImpl[certificates.length];
         try {
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS8Key.java b/pki/base/util/src/netscape/security/pkcs/PKCS8Key.java
index b3ec0790677d0391ac131200dac04df2429b89f6..6fc89610a1366f9e11e059565d383e159d07c7e2 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS8Key.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS8Key.java
@@ -184,7 +184,7 @@ public class PKCS8Key implements PrivateKey {
                 throw new InstantiationException();
             }
 
-            Class keyClass = Class.forName(classname);
+            Class<?> keyClass = Class.forName(classname);
             Object inst;
             PKCS8Key result;
 
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS9Attributes.java b/pki/base/util/src/netscape/security/pkcs/PKCS9Attributes.java
index 6f7ce6abbcd3e675b088efae9ed59efc2efff2c2..485cdded1e2aaa767e3899293675fdb96cda1514 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS9Attributes.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS9Attributes.java
@@ -38,12 +38,12 @@ public class PKCS9Attributes {
     /**
      * Attributes in this set indexed by OID.
      */
-    private final Hashtable attributes = new Hashtable(3);
+    private final Hashtable<ObjectIdentifier, PKCS9Attribute> attributes = new Hashtable<ObjectIdentifier, PKCS9Attribute>(3);
 
     /**
      * The keys of this hashtable are the OIDs of permitted attributes.
      */
-    private final Hashtable permittedAttributes;
+    private final Hashtable<ObjectIdentifier, ObjectIdentifier> permittedAttributes;
 
     /**
      * The DER encoding of this attribute set. The tag byte must be
@@ -73,7 +73,7 @@ public class PKCS9Attributes {
                DerInputStream in) throws IOException {
         if (permittedAttributes != null) {
             this.permittedAttributes =
-                    new Hashtable(permittedAttributes.length);
+                    new Hashtable<ObjectIdentifier, ObjectIdentifier>(permittedAttributes.length);
 
             for (int i = 0; i < permittedAttributes.length; i++)
                 this.permittedAttributes.put(permittedAttributes[i],
@@ -157,7 +157,6 @@ public class PKCS9Attributes {
 
         PKCS9Attribute attrib;
         ObjectIdentifier oid;
-        int index;
 
         for (int i = 0; i < derVals.length; i++) {
             attrib = new PKCS9Attribute(derVals[i]);
@@ -213,14 +212,14 @@ public class PKCS9Attributes {
      * Get an attribute from this set.
      */
     public PKCS9Attribute getAttribute(ObjectIdentifier oid) {
-        return (PKCS9Attribute) attributes.get(oid);
+        return attributes.get(oid);
     }
 
     /**
      * Get an attribute from this set.
      */
     public PKCS9Attribute getAttribute(String name) {
-        return (PKCS9Attribute) attributes.get(PKCS9Attribute.getOID(name));
+        return attributes.get(PKCS9Attribute.getOID(name));
     }
 
     /**
@@ -228,7 +227,6 @@ public class PKCS9Attributes {
      */
     public PKCS9Attribute[] getAttributes() {
         PKCS9Attribute[] attribs = new PKCS9Attribute[attributes.size()];
-        ObjectIdentifier oid;
 
         int j = 0;
         for (int i = 1; i < PKCS9Attribute.PKCS9_OIDS.length &&
@@ -275,7 +273,6 @@ public class PKCS9Attributes {
         StringBuffer buf = new StringBuffer(200);
         buf.append("PKCS9 Attributes: [\n\t");
 
-        ObjectIdentifier oid;
         PKCS9Attribute value;
 
         boolean first = true;
diff --git a/pki/base/util/src/netscape/security/provider/CMS.java b/pki/base/util/src/netscape/security/provider/CMS.java
index fffa00dea22850f36c195308b237bfb4f59738ed..4a4f150abb8ddc41c450617645d81761067ade51 100644
--- a/pki/base/util/src/netscape/security/provider/CMS.java
+++ b/pki/base/util/src/netscape/security/provider/CMS.java
@@ -38,7 +38,7 @@ public final class CMS extends Provider {
         /* We are the SUN provider */
         super("CMS", 1.0, INFO);
 
-        AccessController.doPrivileged(new java.security.PrivilegedAction() {
+        AccessController.doPrivileged(new java.security.PrivilegedAction<Object>() {
             public Object run() {
                 /*
                 * Certificates
diff --git a/pki/base/util/src/netscape/security/provider/DSAKeyFactory.java b/pki/base/util/src/netscape/security/provider/DSAKeyFactory.java
index 1d77a7283c7a5105cfe91ff84e383576a18f87eb..7de0f516e32d633b4ed2f553a1b0d9c615c144be 100755
--- a/pki/base/util/src/netscape/security/provider/DSAKeyFactory.java
+++ b/pki/base/util/src/netscape/security/provider/DSAKeyFactory.java
@@ -122,7 +122,8 @@ public class DSAKeyFactory extends KeyFactorySpi {
      *                inappropriate for the given key, or the given key cannot be processed
      *                (e.g., the given key has an unrecognized algorithm or format).
      */
-    protected KeySpec engineGetKeySpec(Key key, Class keySpec)
+    @SuppressWarnings("unchecked")
+    protected <T extends KeySpec> T engineGetKeySpec(Key key, Class<T> keySpec)
             throws InvalidKeySpecException {
 
         DSAParams params;
@@ -132,21 +133,21 @@ public class DSAKeyFactory extends KeyFactorySpi {
             if (key instanceof java.security.interfaces.DSAPublicKey) {
 
                 // Determine valid key specs
-                Class dsaPubKeySpec = Class.forName
+                Class<?> dsaPubKeySpec = Class.forName
                         ("java.security.spec.DSAPublicKeySpec");
-                Class x509KeySpec = Class.forName
+                Class<?> x509KeySpec = Class.forName
                         ("java.security.spec.X509EncodedKeySpec");
 
                 if (dsaPubKeySpec.isAssignableFrom(keySpec)) {
                     java.security.interfaces.DSAPublicKey dsaPubKey = (java.security.interfaces.DSAPublicKey) key;
                     params = dsaPubKey.getParams();
-                    return new DSAPublicKeySpec(dsaPubKey.getY(),
+                    return (T) new DSAPublicKeySpec(dsaPubKey.getY(),
                             params.getP(),
                             params.getQ(),
                             params.getG());
 
                 } else if (x509KeySpec.isAssignableFrom(keySpec)) {
-                    return new X509EncodedKeySpec(key.getEncoded());
+                    return (T) new X509EncodedKeySpec(key.getEncoded());
 
                 } else {
                     throw new InvalidKeySpecException("Inappropriate key specification");
@@ -155,21 +156,21 @@ public class DSAKeyFactory extends KeyFactorySpi {
             } else if (key instanceof java.security.interfaces.DSAPrivateKey) {
 
                 // Determine valid key specs
-                Class dsaPrivKeySpec = Class.forName
+                Class<?> dsaPrivKeySpec = Class.forName
                         ("java.security.spec.DSAPrivateKeySpec");
-                Class pkcs8KeySpec = Class.forName
+                Class<?> pkcs8KeySpec = Class.forName
                         ("java.security.spec.PKCS8EncodedKeySpec");
 
                 if (dsaPrivKeySpec.isAssignableFrom(keySpec)) {
                     java.security.interfaces.DSAPrivateKey dsaPrivKey = (java.security.interfaces.DSAPrivateKey) key;
                     params = dsaPrivKey.getParams();
-                    return new DSAPrivateKeySpec(dsaPrivKey.getX(),
+                    return (T) new DSAPrivateKeySpec(dsaPrivKey.getX(),
                             params.getP(),
                             params.getQ(),
                             params.getG());
 
                 } else if (pkcs8KeySpec.isAssignableFrom(keySpec)) {
-                    return new PKCS8EncodedKeySpec(key.getEncoded());
+                    return (T) new PKCS8EncodedKeySpec(key.getEncoded());
 
                 } else {
                     throw new InvalidKeySpecException("Inappropriate key specification");
diff --git a/pki/base/util/src/netscape/security/provider/DSAParameters.java b/pki/base/util/src/netscape/security/provider/DSAParameters.java
index cc3012f754c9257c516a43df690a00aa9e20e957..e2a5dd128f229700117e73b0d015522fbc65f3db 100755
--- a/pki/base/util/src/netscape/security/provider/DSAParameters.java
+++ b/pki/base/util/src/netscape/security/provider/DSAParameters.java
@@ -86,13 +86,14 @@ public class DSAParameters extends AlgorithmParametersSpi {
         engineInit(params);
     }
 
-    protected AlgorithmParameterSpec engineGetParameterSpec(Class paramSpec)
+    @SuppressWarnings("unchecked")
+    protected <T extends AlgorithmParameterSpec> T engineGetParameterSpec(Class<T> paramSpec)
             throws InvalidParameterSpecException {
         try {
-            Class dsaParamSpec = Class.forName
+            Class<?> dsaParamSpec = Class.forName
                     ("java.security.spec.DSAParameterSpec");
             if (dsaParamSpec.isAssignableFrom(paramSpec)) {
-                return new DSAParameterSpec(this.p, this.q, this.g);
+                return (T) new DSAParameterSpec(this.p, this.q, this.g);
             } else {
                 throw new InvalidParameterSpecException("Inappropriate parameter Specification");
             }
diff --git a/pki/base/util/src/netscape/security/util/ASN1CharStrConvMap.java b/pki/base/util/src/netscape/security/util/ASN1CharStrConvMap.java
index 972c5784699a569e726fbe4258c46cc9cf49cba0..c9c364f4f7fefa60c12dfe982b9ac352b98f83c0 100644
--- a/pki/base/util/src/netscape/security/util/ASN1CharStrConvMap.java
+++ b/pki/base/util/src/netscape/security/util/ASN1CharStrConvMap.java
@@ -20,7 +20,6 @@ package netscape.security.util;
 import java.nio.charset.Charset;
 import java.nio.charset.CharsetDecoder;
 import java.nio.charset.CharsetEncoder;
-import java.nio.charset.CodingErrorAction;
 import java.util.HashMap;
 import java.util.Iterator;
 import java.util.Map;
diff --git a/pki/base/util/src/netscape/security/util/ByteArrayLexOrder.java b/pki/base/util/src/netscape/security/util/ByteArrayLexOrder.java
index ded4522d970e9ac10e6f213951729e651e2681de..2ee2f740e3af807918711900e5d3a31d4a518809 100644
--- a/pki/base/util/src/netscape/security/util/ByteArrayLexOrder.java
+++ b/pki/base/util/src/netscape/security/util/ByteArrayLexOrder.java
@@ -25,7 +25,7 @@ import java.util.Comparator;
  * @version 1.4 97/12/10
  * @author D. N. Hoover
  */
-public class ByteArrayLexOrder implements Comparator {
+public class ByteArrayLexOrder implements Comparator<byte[]> {
 
     /**
      * Perform lexicographical comparison of two byte arrays,
@@ -41,10 +41,7 @@ public class ByteArrayLexOrder implements Comparator {
      * 
      * @exception <code>ClassCastException</code> if either argument is not a byte array.
      */
-    public final int compare(Object obj1, Object obj2) {
-
-        byte[] bytes1 = (byte[]) obj1;
-        byte[] bytes2 = (byte[]) obj2;
+    public final int compare(byte[] bytes1, byte[] bytes2) {
 
         int diff;
         for (int i = 0; i < bytes1.length && i < bytes2.length; i++) {
diff --git a/pki/base/util/src/netscape/security/util/ByteArrayTagOrder.java b/pki/base/util/src/netscape/security/util/ByteArrayTagOrder.java
index 1367ee043c65159530dc647224ffbe92f9493f42..e57a3b5f11409ae43041277cc05f0580394006ee 100644
--- a/pki/base/util/src/netscape/security/util/ByteArrayTagOrder.java
+++ b/pki/base/util/src/netscape/security/util/ByteArrayTagOrder.java
@@ -19,7 +19,7 @@ package netscape.security.util;
 
 import java.util.Comparator;
 
-public class ByteArrayTagOrder implements Comparator {
+public class ByteArrayTagOrder implements Comparator<byte[]> {
 
     /**
      * Compare two byte arrays, by the order of their tags,
@@ -34,10 +34,7 @@ public class ByteArrayTagOrder implements Comparator {
      * @exception <code>ClassCastException</code> if either argument is not a byte array.
      */
 
-    public final int compare(Object obj1, Object obj2) {
-
-        byte[] bytes1 = (byte[]) obj1;
-        byte[] bytes2 = (byte[]) obj2;
+    public final int compare(byte[] bytes1, byte[] bytes2) {
 
         // tag order is same as byte order ignoring any difference in 
         // the constructivity bit (0x02)
diff --git a/pki/base/util/src/netscape/security/util/DerOutputStream.java b/pki/base/util/src/netscape/security/util/DerOutputStream.java
index 44a4df8f05f4a72e13dc57a13400c87416c7596a..62290d604901f6df7ea2f752abec740c619c4379 100644
--- a/pki/base/util/src/netscape/security/util/DerOutputStream.java
+++ b/pki/base/util/src/netscape/security/util/DerOutputStream.java
@@ -460,7 +460,7 @@ public class DerOutputStream
      * @param order the order to use when sorting encodings of components.
      */
     private void putOrderedSet(byte tag, DerEncoder[] set,
-                   Comparator order) throws IOException {
+                   Comparator<byte[]> order) throws IOException {
         DerOutputStream[] streams = new DerOutputStream[set.length];
 
         for (int i = 0; i < set.length; i++) {
diff --git a/pki/base/util/src/netscape/security/util/ObjectIdentifier.java b/pki/base/util/src/netscape/security/util/ObjectIdentifier.java
index 8dd547760aa8153c7c2c3cd99825622505f5254b..6ff02d1b08ab10c9b4bb8905ef14c9e33e720c5b 100644
--- a/pki/base/util/src/netscape/security/util/ObjectIdentifier.java
+++ b/pki/base/util/src/netscape/security/util/ObjectIdentifier.java
@@ -19,6 +19,7 @@ package netscape.security.util;
 
 import java.io.IOException;
 import java.io.Serializable;
+import java.util.Hashtable;
 import java.util.StringTokenizer;
 
 /**
@@ -376,7 +377,7 @@ final public class ObjectIdentifier implements Serializable {
      * This function never returns null. IOException is raised
      * in error conditions.
      */
-    public static java.util.Hashtable mOIDs = new java.util.Hashtable();
+    public static Hashtable<String, ObjectIdentifier> mOIDs = new Hashtable<String, ObjectIdentifier>();
 
     public static ObjectIdentifier getObjectIdentifier(String oid)
             throws IOException {
@@ -387,7 +388,7 @@ final public class ObjectIdentifier implements Serializable {
 
         oid = oid.trim();
 
-        ObjectIdentifier thisOID = (ObjectIdentifier) mOIDs.get(oid);
+        ObjectIdentifier thisOID = mOIDs.get(oid);
         if (thisOID != null)
             return thisOID;
 
diff --git a/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java b/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
index 320bbf3df24df42461626b833fc820091ec9baa7..c749ae04eb9c4316cd0aa0ebccacffdcfe39916f 100644
--- a/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
+++ b/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
@@ -29,7 +29,6 @@ import java.util.Vector;
 
 import netscape.security.util.BitArray;
 import netscape.security.util.DerOutputStream;
-import netscape.security.x509.FreshestCRLExtension.Reason;
 
 import org.mozilla.jss.asn1.ASN1Util;
 import org.mozilla.jss.asn1.InvalidBERException;
